// ReverseText.java

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JLayer;
import javax.swing.JPanel;
import javax.swing.JTextField;

import javax.swing.plaf.LayerUI;

public class ReverseText
{
   private static Color PALE_YELLOW = new Color (1.0f, 1.0f, 0.0f, 0.2f);
   private static Color PALE_GREEN = new Color (0.0f, 1.0f, 0.0f, 0.2f);

   private static JLayer<JPanel> createLayer ()
   {
      LayerUI<JPanel> layerUI;
      layerUI = new LayerUI<JPanel> ()
      {
         public void paint (Graphics g, JComponent c)
         {
            // Paint the wallpaper.

            Graphics2D g2 = (Graphics2D) g;
            g2.setPaint (new GradientPaint (0, 0, PALE_YELLOW,
                                            5, 0, PALE_GREEN, true));
            g2.fillRect (0, 0, c.getWidth (), c.getHeight ());

            // Make sure that layer's panel view is not opaque.

            JLayer l = (JLayer) c;
            if (l.getView ().isOpaque ())
                ((JPanel) l.getView ()).setOpaque (false);

            // Paint the view minus its background.

            super.paint (g, c);
         }
      };

      // Create a user interface to be decorated.

      JPanel pnl = new JPanel ();
      JLabel lblName = new JLabel ("Name:");
      pnl.add (lblName);
      final JTextField txtName = new JTextField (20);
      pnl.add (txtName);
      JButton btnReverse = new JButton ("Reverse");
      pnl.add (btnReverse);

      ActionListener al;
      al = new ActionListener ()
           {
               public void actionPerformed (ActionEvent ae)
               {
                  String txt = txtName.getText ();
                  txt = new StringBuffer (txt).reverse ().toString ();
                  txtName.setText (txt);
               }
           };
      btnReverse.addActionListener (al);

      // Create the layer for the panel using our custom layerUI.

      return new JLayer<JPanel> (pnl, layerUI);
   }

   private static void createAndShowUI ()
   {
      JFrame frame = new JFrame ("Reverse Text");
      frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);

      frame.add (createLayer ());

      frame.pack ();
      frame.setLocationRelativeTo (null);
      frame.setVisible (true);
   }

   public static void main (String [] args)
   {
      Runnable r = new Runnable ()
                   {
                       public void run ()
                       {
                          createAndShowUI ();
                       }
                   };
      EventQueue.invokeLater (r);
   }
}
